LeetCode Q 740 - Delete and Earn
Given an array nums of integers, you can perform operations on the array.
In each operation, you pick any nums[i] and delete it to earn nums[i] points. After, you must delete every element equal to nums[i] - 1 or nums[i] + 1.
You start with 0 points. Return the maximum number of points you can earn by applying such operations.
Example 1:Input: nums = [3, 4, 2] ; Output: 6
Explanation: Delete 4 to earn 4 points, consequently 3 is also deleted. Then, delete 2 to earn 2 points. 6 total points are earned.
Example 2:Input: nums = [2, 2, 3, 3, 3, 4] ; Output: 9
Explanation: Delete 3 to earn 3 points, deleting both 2’s and the 4.
Then, delete 3 again to earn 3 points, and 3 again to earn 3 points.
9 total points are earned.
Note:
- The length of nums is at most 20000.
- Each element nums[i] is an integer in the range [1, 10000].
Solution :
Solution 1: DP
First, We use an array int[] count
store the times of each element appeared in nums. Since nums[i] is in the range [1, 10000]. We can initialize int[] count = new int[10001]
.
Then, traverse nums and build count.
Next, use DP algorithm to find the answer.
- State:
dp[i]
, the best score we can get till i. - State Transfer Function:
dp[i] = Math.max(dp[i - 1], dp[i - 2] + i * counter[i]);
We have two options:
- We pick i. Since we must delete i-1 and i+1, that is we can only reach i from i-2.
- We don’t pick i. We pick i - 1.
We choose one from these two options, which has higher value.
Time Complexity: O(n)
Space Complexity: O(n)
Code:
public int deleteAndEarn(int[] nums) {
if (nums == null || nums.length == 0) return 0;
int[] count = new int[10001];
for (int num: nums) count[num]++;
int[] dp = new int[10001];
dp[1] = count[1];
for (int i = 2; i < 10001; i++) {
dp[i] = Math.max(dp[i - 1], dp[i - 2] + i * counter[i]);
}
return dp[10000];
}